# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rosee_msg/GraspingPrimitiveAggregated.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class GraspingPrimitiveAggregated(genpy.Message):
  _md5sum = "9923434b3aad5f3430b0b5e22d639c19"
  _type = "rosee_msg/GraspingPrimitiveAggregated"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """## Info about aggregated primitive (for all trig there is only a single message)
## used only by GUI for now

# name of the action
string action_name

uint8 PRIMITIVE_PINCHSTRONG = 0
uint8 PRIMITIVE_PINCHWEAK = 1
uint8 PRIMITIVE_MULTIPLEPINCHSTRONG = 2
uint8 PRIMITIVE_TRIG = 3
uint8 PRIMITIVE_TIPFLEX = 4
uint8 PRIMITIVE_FINGFLEX = 5
uint8 PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 6
uint8 PRIMITIVE_NONE = 7
uint8 primitive_type

# names of the selectable fingers/joints ALL aggregated. This means that
# for example, a trig primitive will have in this field all the fingers that can be used
# for a trig; also the pinch, and the "pairing" info here is lost (can be retrieved 
# by the other service SelectablePairInfo
string[] selectable_names

# number of necessary selectable_names to select before sending message
# (eg 1 for trig, 2 for pinch, 1 for moreTips)
uint8 max_selectable

"""
  # Pseudo-constants
  PRIMITIVE_PINCHSTRONG = 0
  PRIMITIVE_PINCHWEAK = 1
  PRIMITIVE_MULTIPLEPINCHSTRONG = 2
  PRIMITIVE_TRIG = 3
  PRIMITIVE_TIPFLEX = 4
  PRIMITIVE_FINGFLEX = 5
  PRIMITIVE_SINGLEJOINTMULTIPLETIPS = 6
  PRIMITIVE_NONE = 7

  __slots__ = ['action_name','primitive_type','selectable_names','max_selectable']
  _slot_types = ['string','uint8','string[]','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       action_name,primitive_type,selectable_names,max_selectable

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(GraspingPrimitiveAggregated, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.action_name is None:
        self.action_name = ''
      if self.primitive_type is None:
        self.primitive_type = 0
      if self.selectable_names is None:
        self.selectable_names = []
      if self.max_selectable is None:
        self.max_selectable = 0
    else:
      self.action_name = ''
      self.primitive_type = 0
      self.selectable_names = []
      self.max_selectable = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.action_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.primitive_type
      buff.write(_get_struct_B().pack(_x))
      length = len(self.selectable_names)
      buff.write(_struct_I.pack(length))
      for val1 in self.selectable_names:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self.max_selectable
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_name = str[start:end]
      start = end
      end += 1
      (self.primitive_type,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.selectable_names = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.selectable_names.append(val1)
      start = end
      end += 1
      (self.max_selectable,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.action_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.primitive_type
      buff.write(_get_struct_B().pack(_x))
      length = len(self.selectable_names)
      buff.write(_struct_I.pack(length))
      for val1 in self.selectable_names:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      _x = self.max_selectable
      buff.write(_get_struct_B().pack(_x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.action_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.action_name = str[start:end]
      start = end
      end += 1
      (self.primitive_type,) = _get_struct_B().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.selectable_names = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.selectable_names.append(val1)
      start = end
      end += 1
      (self.max_selectable,) = _get_struct_B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
